# Contributing

[Software Carpentry][swc-site] is an open source project,
and we welcome contributions of all kinds:
new lessons,
fixes to existing material,
bug reports,
and reviews of proposed changes are all equally welcome.
By contributing,
you are agreeing that we may redistribute your work under [our license](LICENSE.md).
You also agree to abide by our [code of conduct](CONDUCT.md).

## Getting Started

1.  We use [GitHub flow][github-flow] to manage changes.  In brief:
    1.  Create a new branch in your desktop copy of this repository for each significant change.
    2.  Commit the change in that branch.
    3.  Push that branch to your fork of this repository on GitHub.
    4.  Submit a pull request from that branch to the [master repository][repo].
    5.  If you receive feedback,
        make changes on your desktop and push to your branch on GitHub:
        the pull request will update automatically.

2.  The published copy of the lesson is in the `gh-pages` branch of the repository
    (so that GitHub will regenerate it automatically).
    Please create all branches from that,
    and merge the [master repository][repo]'s `gh-pages` branch into your `gh-pages` branch
    before starting major work.

## Other Ideas

If you are looking for other things to work on,
please see [the list of issues for this repository][issues],
or the other [Data Carpentry][dc-lessons]
and [Software Carpentry][swc-lessons] lessons.
Comments on issues and reviews of pull requests are equally welcome.

[github-flow]: https://guides.github.com/introduction/flow/
[repo]: https://github.com/gvwilson/new-lesson-example/
[swc-lessons]: http://software-carpentry.org/lessons/
[swc-site]: http://software-carpentry.org/
